# Møller–Plesset Correlation Energy Density Generator

This is python code of generating MP2, MP3, and MP4 correlation energy density based on **one boby decomposition scheme** (https://doi.org/10.1002/qua.22017)

Requirement of python packages:
```shell
numpy, scipy, h5py, torch, quadpy, itertools, mmap, tqdm
```
Optional of python packages:
```shell
pycuda, skcuda # if you use GPU for preparing Ajb
```
Requirement of external packages to run example files:
```shell
Psi4 # to generate wavefunction and FCIDUMP file
molden2aim # to convert molden format to .WFN
```


## Examples
### ch4_200_031
This is to calculate energy density on Carbon and Hydrogen atom of CH4@3-21g with grid settings:
Legendre quadrature (200 radial points) and Lebedev quadrature (noted as 031, 350 angular points).

```shell
# prepare wavefunction and FCIDUMP files, here we use Psi4 package
# one can also use other packages, e.g. PySCF, OpenMolcas
cd examples/ch4_200_031/calcu/
psi4 -n 8 -i input.dat -o output.dat

# convert molden format of wavefunction and txt format of FCIDUMP (in Psi 4 is INPDUMP)
# into .npy files
# Note that external package is needed to convert molden to .wfn first, we use molden2aim 
# (https://github.com/zorkzou/Molden2AIM) for example.
cd ../prep/
chmod +x mlcorr_prep.sh
./mlcorr_prep.sh ch4

# calculate MP2 MP3 MP4 energy density
cd ../eneden/
chmod +x eneden.sh
./eneden.sh ch4
```


