import numpy as np
import sys
import os
import re
import h5py
import mmap


def orb(line):
  pattern = r'=(.*?),'
  num_orb = re.search(pattern, line).group(1).strip()
  print(num_orb)
  
  return int(num_orb)

def find_start2el(inf):
  pattern = r'END'
  lines = next(inf.index(i) for i in inf if re.search(pattern, i) is not None)
  print(int(lines) + 1)

  return int(lines) + 1

def find_end2el(inf):
  pattern = r'(\s+)1(\s+)1(\s+)0(\s+)0(\s+)'
  rinf = inf[::-1]
  rlines = next(rinf.index(i) for i in rinf if re.search(pattern, i) is not None)
  lines = len(inf)-1-rlines
  print(int(lines) - 1)

  return int(lines) - 1


ffci = sys.argv[1]

ffci = open(ffci, 'rb')


# load the whole file
fmapped = mmap.mmap(ffci.fileno(), 0, access=mmap.ACCESS_READ)
#mapped = fmapped.readlines()
inf = []
for line in iter(fmapped.readline, b""):
  inf.append(line.decode('utf-8'))
'''

inf = ffci.readlines()
'''
#print(inf)

nline = 1

# get number of primitives
num_orb = orb(inf[nline])

# find the line of "/", next line is first 2-ele terms
start2el = find_start2el(inf)

# find the line of last 2-ele terms
end2el = find_end2el(inf)

#print(str(start2el))
#print(str(end2el))

# assigne the region of 2-ele and 1-ele terms
list2el = inf[start2el:end2el+1]
#print(start2el)
#print(end2el)
list1el = inf[end2el+1:-1]

# feed the value to matrix
int2el = np.zeros((num_orb,num_orb,num_orb,num_orb), dtype=np.float32)
#print(int2el.shape)
for t in list2el:
  i,a,j,b = [x-1 for x in map(int, t.split()[1:])]
  val = t.split()[0]
  int2el[i,j,a,b] = val
  int2el[i,b,a,j] = val
  int2el[a,j,i,b] = val
  int2el[a,b,i,j] = val
  int2el[j,i,b,a] = val
  int2el[b,i,j,a] = val
  int2el[j,a,b,i] = val
  int2el[b,a,j,i] = val

int1el = np.zeros((num_orb,num_orb), dtype=np.float32)
for t in list1el:
  i,a,j,b = [x-1 for x in map(int, t.split()[1:])]
  val = t.split()[0]
  int1el[i,a] = val
  int1el[a,i] = val

# save it to npy
#np.save(os.path.basename(ffci).split('.')[0] + '_int2el.npy',int2el)
#np.save(os.path.basename(ffci).split('.')[0] + '_int1el.npy',int1el)
np.save('FCIDUMP_int2el.npy',np.asarray(int2el, dtype=np.float32))       


#print(num_orb)
#print(start2el)
#print(end2el)



